#ifndef MATRIX_H
#define MATRIX_H

#define DOT     %
#define CROSS   ^

#include "types.h"

class MATRIX
{
public:
    float   MMat[4][4];
    float   UMat[4][4];
    float   TMat[4][4];

                 MATRIX();
    int         Identity();
    int         TransformWithCamera(LANDSCAPE *land);
    int         TransformWithCamera(BITMAPOBJ *bobj);
	int 		FixBObject(BITMAPOBJ *bobj);
    int         Scale(float sx, float sy, float sz);
    int         Rotate(float ax, float ay, float az);
    int         Translate(float xt, float yt, float zt);
    void        Multiply(float *dest, float *mat1, float *mat2);
//    void        Multiply(float dest[4][4], float mat1[4][4], float mat2[4][4]);
    void        Copy(float *dest, float *src);
};

float       operator%(VECTOR Vector1, VECTOR Vector2);
VECTOR		operator^(VECTOR Vector1, VECTOR Vector2);
void        VectorLength(VECTOR *Vector);
void        Normalize(VECTOR *Vector);

#endif
