'****************************************************************
'****************************************************************
'**                                                            **
'**  (C) Copyright NetManage, Inc. 1993 - All rights reserved  **
'**                                                            **
'**  File:  WINSOCK.BAS                                        **
'**                                                            **
'**  Date:  October 3, 1993                                    **
'**                                                            **
'**  Description:   This file contains definitions and         **
'**                 declarations for the WinSock  V1.1 library.**
'**                                                            **
'****************************************************************
'****************************************************************
                   
'*********************************************
'***                                       ***
'***  S Y M B O L I C   C O N S T A N T S  ***
'***                                       ***
'*********************************************

'***  Select uses arrays of SOCKETs.  These
'***  "macros" manipulate such arrays. FD_SETSIZE may be
'***  defined by the user, but the default here should be >= 64
Global Const FD_SETSIZE = 64

Type fd_set
    fd_count As Integer
    fd_array(FD_SETSIZE) As Integer
End Type

'*************************************
'***  T I M E   S T R U C T U R E  ***
'*************************************
Type timeval
    tv_sec As Long      'Seconds since Jan 1, 1970
    tv_usec As Long     'and microseconds
End Type

'***************
'***  IOCTL  ***
'***************
Global Const IOCPARM_MASK% = &H7F       '* Parameters must be < 128 bytes **
Global Const IOC_VOID& = &H20000000     '* No parameters **
Global Const IOC_OUT& = &H40000000      '* Copy out parameters **
Global Const IOC_IN& = &H80000000       '* Copy in parameters **
Global Const IOC_INOUT& = (IOC_IN Or IOC_OUT)

Global Const FIONREAD& = &H4004667F
Global Const FIONBIO& = &H8004667E
Global Const FIOASYNC& = &H8004667D

'* Socket I/O Controls

Global Const SIOCSHIWAT& = &H80047300
Global Const SIOCGHIWAT& = &H40047301
Global Const SIOCSLOWAT& = &H80047302
Global Const SIOCGLOWAT& = &H40047303
Global Const SIOCATMARK& = &H40047307


'*******************************************
'***  H O S T E N T   S T R U C T U R E  ***
'*******************************************
Type HostEntType
    h_name As Long          'LPstr
    h_aliases As Long       'LPstr to *h_aliases
    h_addrtype As Integer   'Plain int
    h_length As Integer     'Plain int
    h_addr As Long          'LPstr
End Type

'***********************************************************
'***  N E T W O R K    E N T I T Y    S T R U C T U R E  ***
'***********************************************************
Type netent
    n_name As Long
    n_aliases As Long
    n_addrtype As Integer
    n_net As Long
End Type

'*********************************************************
'***  S E R V I C E   E N T I T Y   S T R U C T U R E  ***
'*********************************************************
Type servent
    s_name As Long      '**  Official name of service   **
    s_aliases As Long   '**  Alias list                 **
    s_port As Integer   '**  Port service resides at    **
    s_proto As Long     '**  Protocol to use            **
End Type

'***********************************************************
'***  P R O T O C O L   E N T I T Y   S T R U C T U R E  ***
'***********************************************************
Type protoent
    p_name As Long
    p_aliases As Long
    p_proto As Integer
End Type

'*****************
'**  Protocols  **
'*****************
Global Const IPPROTO_IP% = 0        '* dummy for IP **
Global Const IPPROTO_ICMP% = 1      '* control message protocol **
Global Const IPPROTO_GGP% = 2       '* gateway^2 (deprecated) **
Global Const IPPROTO_TCP% = 6       '* tcp **
Global Const IPPROTO_PUP% = 12      '* pup **
Global Const IPPROTO_UDP% = 17      '* user datagram protocol **
Global Const IPPROTO_IDP% = 22      '* xns idp **
Global Const IPPROTO_ND% = 77       '* UNOFFICIAL net disk proto **

Global Const IPPROTO_RAW% = 255     '* raw IP packet **
Global Const IPPROTO_MAX% = 256

'*********************************************************************
'**    Port/socket numbers: network standard functions              **
'*********************************************************************
Global Const IPPORT_ECHO% = 7
Global Const IPPORT_DISCARD% = 9
Global Const IPPORT_SYSTAT% = 11
Global Const IPPORT_DAYTIME% = 13
Global Const IPPORT_NETSTAT% = 15
Global Const IPPORT_FTP% = 21
Global Const IPPORT_TELNET% = 23
Global Const IPPORT_SMTP% = 25
Global Const IPPORT_TIMESERVER% = 37
Global Const IPPORT_NAMESERVER% = 42
Global Const IPPORT_WHOIS% = 43
Global Const IPPORT_MTP% = 57

'*********************************************************************
'**                                                                 **
'**    Port/socket numbers: host specific functions                 **
'**                                                                 **
'*********************************************************************
Global Const IPPORT_TFTP% = 69
Global Const IPPORT_RJE% = 77
Global Const IPPORT_FINGER% = 79
Global Const IPPORT_TTYLINK% = 87
Global Const IPPORT_SUPDUP% = 95

'*********************************************************************
'**                                                                 **
'**   UNIX TCP sockets                                              **
'**                                                                 **
'*********************************************************************
Global Const IPPORT_EXECSERVER% = 512
Global Const IPPORT_LOGINSERVER% = 513
Global Const IPPORT_CMDSERVER% = 514
Global Const IPPORT_EFSSERVER% = 520

'*********************************************************************
'**                                                                 **
'**   UNIX UDP sockets                                              **
'**                                                                 **
'*********************************************************************
Global Const IPPORT_BIFFUDP% = 512
Global Const IPPORT_WHOSERVER% = 513
Global Const IPPORT_ROUTESERVER% = 520      '* 520+1 also used **

'*********************************************************************
'**                                                                 **
'**    Ports < IPPORT_RESERVED are reserved for                     **
'**    privileged processes (e.g. root).                            **
'**                                                                 **
'*********************************************************************
Global Const IPPORT_RESERVED% = 1024

'*********************************************************************
'**                                                                 **
'**   Link Numbers                                                  **
'**                                                                 **
'*********************************************************************
Global Const IMPLINK_IP% = 155
Global Const IMPLINK_LOWEXPER% = 156
Global Const IMPLINK_HIGHEXPER% = 158

'*******************************************************************
'***  I N _ A D D R   U N I O N                                  ***
'*******************************************************************
Type in_addr
    in_addr_Union As Long
End Type

'*****************************
'***  I N _ A D D R _ S B  ***
'*****************************
Type in_addr_sb
    s_b1 As String * 1
    s_b2 As String * 1
    s_b3 As String * 1
    s_b4 As String * 1
End Type
 
'*****************************
'***  I N _ A D D R _ S W  ***
'*****************************
Type in_addr_sw
    s_w1 As Integer
    s_w2 As Integer
End Type

'***********************************
'***  I N _ A D D R _ S A D D R  ***
'***********************************
Type in_addr_saddr
    S_addr As Long
End Type

Global Const IN_CLASSA_NET& = &HFF000000
Global Const IN_CLASSA_NSHIFT% = 24
Global Const IN_CLASSA_HOST& = &HFFFFFF
Global Const IN_CLASSA_MAX% = 128

Global Const IN_CLASSB_NET& = &HFFFF0000
Global Const IN_CLASSB_NSHIFT% = 16
Global Const IN_CLASSB_HOST& = &HFFFF
Global Const IN_CLASSB_MAX = 65536

Global Const IN_CLASSC_NET& = &HFFFFFF00
Global Const IN_CLASSC_NSHIFT% = 8
Global Const IN_CLASSC_HOST& = &HFF

'*******************************
'**  Common IP address types  **
'*******************************
Global Const INADDR_ANY& = &H0              '** Of type long
Global Const INADDR_LOOPBACK& = &H7F000001
Global Const INADDR_BROADCAST& = &HFFFFFFFF
Global Const INADDR_NONE& = &HFFFFFFFF

'*******************************
'***  S O C K A D D R _ I N  ***
'*******************************
Type sockaddr_in
    sin_family As Integer
    sin_port As Integer
    sin_addr As Long
    sin_zero As String * 8
End Type

Global Const WSADescription_Len = 256
Global Const WSASys_Status_Len = 128
Global Const WSADescription_LenP = WSADescription_Len + 1
Global Const WSASys_Status_LenP = WSASys_Status_Len + 1

Type WSADATA
    wVersion As Integer
    wHighVersion As Integer
    szDescription As String * WSADescription_LenP
    szSystemStatus As String * WSASys_Status_LenP
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpVendorInfo As Long
End Type

Global Const IP_OPTIONS% = 1

Global Const INVALID_SOCKET% = -1
Global Const SOCKET_ERROR% = -1

'*************
'**  Types  **
'*************
Global Const SOCK_STREAM% = 1   '* stream socket **
Global Const SOCK_DGRAM% = 2    '* datagram socket **
Global Const SOCK_RAW% = 3      '* raw-protocol interface **
Global Const SOCK_RDM% = 4      '* reliably-delivered message **
Global Const SOCK_SEQPACKET% = 5'* sequenced packet stream **

'**********************
'**  Socket options  **
'**********************
Global Const SO_DEBUG% = &H1            '* turn on debugging info recording **
Global Const SO_ACCEPTCONN% = &H2       '* socket has had listen()          **
Global Const SO_REUSEADDR% = &H4        '* allow local address reuse        **
Global Const SO_KEEPALIVE% = &H8        '* keep connections alive           **
Global Const SO_DONTROUTE% = &H10       '* just use interface address       **
Global Const SO_BROADCAST% = &H20       '* permit sending of broadcast msgs **
Global Const SO_USELOOPBACK% = &H40     '* bypass harware when possible     **
Global Const SO_LINGER% = &H80          '* linger on close if data present  **
Global Const SO_OOBINLINE% = &H100      '* leave received OOB data in line  **

Global Const SO_DONTLINGER = -SO_LINGER

Global Const SO_SNDBUF% = &H1001        '* send buffer size                 **
Global Const SO_RCVBUF% = &H1002        '* receive buffer size              **
Global Const SO_SNDLOWAT% = &H1003      '* send low-water mark              **
Global Const SO_RCVLOWAT% = &H1004      '* receive low-water mark           **
Global Const SO_SNDTIMEO% = &H1005      '* send timeout                     **
Global Const SO_RCVTIMEO% = &H1006      '* receive timeout                  **
Global Const SO_ERROR% = &H1007         '* get error status and clear       **
Global Const SO_TYPE% = &H1008          '* get socket type                  **

Global Const TCP_NODELAY% = &H1

'************************
'**  Address Families  **
'************************
Global Const AF_UNSPEC% = 0         '* unspecified **
Global Const AF_UNIX% = 1           '* local to host (pipes, portals)
Global Const AF_INET% = 2           '* internetwork: UDP, TCP, etc. **
Global Const AF_IMPLINK% = 3        '* arpanet imp addresses **
Global Const AF_PUP% = 4            '* pup protocols: e.g. BSP **
Global Const AF_CHAOS% = 5          '* mit CHAOS protocols **
Global Const AF_NS% = 6             '* XEROX NS protocols **
Global Const AF_ISO% = 7            '* nbs protocols **
Global Const AF_OSI% = AF_ISO%      '* OSI is ISO
Global Const AF_ECMA% = 8           '* european computer manufacturers
Global Const AF_DATAKIT% = 9        '* datakit protocols **
Global Const AF_CCITT% = 10         '* CCITT protocols, X.25 etc **
Global Const AF_SNA% = 11           '* IBM SNA **
Global Const AF_DECnet% = 12        '* DECnet **
Global Const AF_DLI% = 13           '* Direct data link interface **
Global Const AF_LAT% = 14           '* LAT **
Global Const AF_HYLINK% = 15        '* NSC Hyperchannel **
Global Const AF_APPLETALK% = 16     '* Apple Talk **
Global Const AF_NETBIOS% = 17       '* Netbios-style addresses **

Global Const AF_MAX% = 18

'**********************************************
'**  STRUCTURE USED TO STORE MOST ADDRESSES  **
'**********************************************
Type sockaddr
    sa_family As Integer    '*  Address family                    **
    sa_data As String * 14  '*  Up to 14 bytes of direct address  **
End Type

Type sockproto
    sp_family As Integer
    sp_protocol As Integer
End Type

'************************************************************
'**  Protocol Families, same as Address Families for now.  **
'************************************************************
Global Const PF_UNSPEC% = AF_UNSPEC        '* unspecified **
Global Const PF_UNIX% = AF_UNIX%           '* local to host (pipes, portals)
Global Const PF_INET% = AF_INET%           '* internetwork: UDP, TCP, etc. **
Global Const PF_IMPLINK% = AF_IMPLINK%     '* arpanet imp addresses **
Global Const PF_PUP% = AF_PUP%             '* pup protocols: e.g. BSP **
Global Const PF_CHAOS% = AF_CHAOS%         '* mit CHAOS protocols **
Global Const PF_NS% = AF_NS%               '* XEROX NS protocols **
Global Const PF_ISO% = AF_ISO%             '* nbs protocols **
Global Const PF_OSI% = AF_OSI%             '* OSI is ISO
Global Const PF_ECMA% = AF_ECMA%           '* european computer manufacturers
Global Const PF_DATAKIT% = AF_DATAKIT%     '* datakit protocols **
Global Const PF_CCITT% = AF_CCITT%         '* CCITT protocols, X.25 etc **
Global Const PF_SNA% = AF_SNA%             '* IBM SNA **
Global Const PF_DECnet% = AF_DECnet%       '* DECnet **
Global Const PF_DLI% = AF_DLI%             '* Direct data link interface **
Global Const PF_LAT% = AF_LAT%             '* LAT **
Global Const PF_HYLINK% = AF_HYLINK%       '* NSC Hyperchannel **
Global Const PF_APPLETALK% = AF_APPLETALK% '* Apple Talk **
Global Const PF_NETBIOS% = AF_NETBIOS%     '* Netbios-style addresses **

Global Const PF_MAX% = AF_MAX%

'******************************************************
'**  Structure used for manipulating linger options  **
'******************************************************
Type linger
    l_onoff As Integer    '* option on/off
    l_linger As Integer   '* linger time
End Type

'********************************************************************
'**  Level number for (get/set)sockopt() to apply to socket itself **
'********************************************************************

Global Const SOL_SOCKET% = &HFFFF       '**  option for socket level  **

'* Maximum queue length specifiable by listen

Global Const SOMAXCON% = 5

Global Const MSG_OOB% = 1
Global Const MSG_PEEK% = 2
Global Const MSG_DONTROUTE% = 4

Global Const MSG_MAXIOVLEN% = 16

'* Define constant based on RFC883, used by gethostbyxxxx() calls

Global Const MAXGETHOSTSTRUCT% = 1024

'* Define flags to be used with the WSAAsyncSelect() call.

Global Const FD_READ% = &H1
Global Const FD_WRITE% = &H2
Global Const FD_OOB% = &H4
Global Const FD_ACCEPT% = &H8
Global Const FD_CONNECT% = &H10
Global Const FD_CLOSE% = &H20

'***************************************************************************************
'**                                                                                   **
'**    Error codes                                                                    **
'**    All Windows Sockets error constants are biased by WSABASEERR from the "normal" **
'**                                                                                   **
'***************************************************************************************
Global Const WSABASEERR% = 10000

'* Windows Sockets definitions of regular Microsoft C error constants

Global Const WSAEINTR% = WSABASEERR + 4
Global Const WSAEBADF% = WSABASEERR + 9
Global Const WSAEACCES% = WSABASEERR + 13
Global Const WSAEFAULT% = WSABASEERR + 14
Global Const WSAEINVAL% = WSABASEERR + 22
Global Const WSAEMFILE% = WSABASEERR + 24

'* Windows Sockets definitions of regular Berkeley error constants

Global Const WSAEWOULDBLOCK% = WSABASEERR + 35
Global Const WSAEINPROGRESS% = WSABASEERR + 36
Global Const WSAEALREADY% = WSABASEERR + 37
Global Const WSAENOTSOCK% = WSABASEERR + 38
Global Const WSAEDESTADDRREQ% = WSABASEERR + 39
Global Const WSAEMSGSIZE% = WSABASEERR + 40
Global Const WSAEPROTOTYPE% = WSABASEERR + 41
Global Const WSAENOPROTOOPT% = WSABASEERR + 42
Global Const WSAEPROTONOSUPPORT% = WSABASEERR + 43
Global Const WSAESOCKTNOSUPPORT% = WSABASEERR + 44
Global Const WSAEOPNOTSUPP% = WSABASEERR + 45
Global Const WSAEPFNOSUPPORT% = WSABASEERR + 46
Global Const WSAEAFNOSUPPORT% = WSABASEERR + 47
Global Const WSAEADDRINUSE% = WSABASEERR + 48
Global Const WSAEADDRNOTAVAIL% = WSABASEERR + 49
Global Const WSAENETDOWN% = WSABASEERR + 50
Global Const WSAENETUNREACH% = WSABASEERR + 51
Global Const WSAENETRESET% = WSABASEERR + 52
Global Const WSAECONNABORTED% = WSABASEERR + 53
Global Const WSAECONNRESET% = WSABASEERR + 54
Global Const WSAENOBUFS% = WSABASEERR + 55
Global Const WSAEISCONN% = WSABASEERR + 56
Global Const WSAENOTCONN% = WSABASEERR + 57
Global Const WSAESHUTDOWN% = WSABASEERR + 58
Global Const WSAETOOMANYREFS% = WSABASEERR + 59
Global Const WSAETIMEDOUT% = WSABASEERR + 60
Global Const WSAECONNREFUSED% = WSABASEERR + 61
Global Const WSAELOOP% = WSABASEERR + 62
Global Const WSAENAMETOOLONG% = WSABASEERR + 63
Global Const WSAEHOSTDOWN% = WSABASEERR + 64
Global Const WSAEHOSTUNREACH% = WSABASEERR + 65
Global Const WSAENOTEMPTY% = WSABASEERR + 66
Global Const WSAEPROCLIM% = WSABASEERR + 67
Global Const WSAEUSERS% = WSABASEERR + 68
Global Const WSAEDQUOT% = WSABASEERR + 69
Global Const WSAESTALE% = WSABASEERR + 70
Global Const WSAEREMOTE% = WSABASEERR + 71

'* Extended Windows Sockets error constants definitions

Global Const WSASYSNOTREADY% = WSABASEERR + 91
Global Const WSAVERNOTSUPPORTED% = WSABASEERR + 92
Global Const WSANOTINITIALIZED% = WSABASEERR + 93


Global Const WSAHOST_NOT_FOUND% = WSABASEERR + 1001
Global Const WSATRY_AGAIN% = WSABASEERR + 1002
Global Const WSANO_RECOVERY% = WSABASEERR + 1003
Global Const WSANO_DATA% = WSABASEERR + 1004
Global Const WSANO_ADDRESS% = WSANO_DATA

'***********************************************************************
'** Windows Sockets errors redefined as regular Berkeley error constants
'***********************************************************************

Global Const EWOULDBLOCK% = WSABASEERR + 35
Global Const EINPROGRESS% = WSABASEERR + 36
Global Const EALREADY% = WSABASEERR + 37
Global Const ENOTSOCK% = WSABASEERR + 38
Global Const EDESTADDRREQ% = WSABASEERR + 39
Global Const EMSGSIZE% = WSABASEERR + 40
Global Const EPROTOTYPE% = WSABASEERR + 41
Global Const ENOPROTOOPT% = WSABASEERR + 42
Global Const EPROTONOSUPPORT% = WSABASEERR + 43
Global Const ESOCKTNOSUPPORT% = WSABASEERR + 44
Global Const EOPNOTSUPP% = WSABASEERR + 45
Global Const EPFNOSUPPORT% = WSABASEERR + 46
Global Const EAFNOSUPPORT% = WSABASEERR + 47
Global Const EADDRINUSE% = WSABASEERR + 48
Global Const EADDRNOTAVAIL% = WSABASEERR + 49
Global Const ENETDOWN% = WSABASEERR + 50
Global Const ENETUNREACH% = WSABASEERR + 51
Global Const ENETRESET% = WSABASEERR + 52
Global Const ECONNABORTED% = WSABASEERR + 53
Global Const ECONNRESET% = WSABASEERR + 54
Global Const ENOBUFS% = WSABASEERR + 55
Global Const EISCONN% = WSABASEERR + 56
Global Const ENOTCONN% = WSABASEERR + 57
Global Const ESHUTDOWN% = WSABASEERR + 58
Global Const ETOOMANYREFS% = WSABASEERR + 59
Global Const ETIMEDOUT% = WSABASEERR + 60
Global Const ECONNREFUSED% = WSABASEERR + 61
Global Const ELOOP% = WSABASEERR + 62
Global Const ENAMETOOLONG% = WSABASEERR + 63
Global Const EHOSTDOWN% = WSABASEERR + 64
Global Const EHOSTUNREACH% = WSABASEERR + 65
Global Const ENOTEMPTY% = WSABASEERR + 66
Global Const EPROCLIM% = WSABASEERR + 67
Global Const EUSERS% = WSABASEERR + 68
Global Const EDQUOT% = WSABASEERR + 69
Global Const ESTALE% = WSABASEERR + 70
Global Const EREMOTE% = WSABASEERR + 71

Global Const HOST_NOT_FOUND% = WSABASEERR + 1001
Global Const TRY_AGAIN% = WSABASEERR + 1002
Global Const NO_RECOVERY% = WSABASEERR + 1003
Global Const NO_DATA% = WSABASEERR + 1004
Global Const NO_ADDRESS% = WSANO_DATA



'**********************************************************************
'***                                                                ***
'***              W I N S O C K . D L L   P R O T O T Y P E S       ***
'***                                                                ***
'**********************************************************************

Declare Function accept Lib "WinSock.DLL" (ByVal s As Integer, addr As sockaddr_in, addrlen As Integer) As Integer
Declare Function bind Lib "WinSock.DLL" (ByVal s As Integer, addr As sockaddr_in, ByVal addrlen As Integer) As Integer
Declare Function closesocket Lib "WinSock.DLL" (ByVal s As Integer) As Integer
Declare Function connect Lib "WinSock.DLL" (ByVal s As Integer, addr As sockaddr_in, ByVal addrlen As Integer) As Integer
Declare Function ioctlsocket Lib "WinSock.DLL" (ByVal s As Integer, ByVal cmd As Long, arg As Long) As Integer
Declare Function getpeername Lib "WinSock.DLL" (ByVal s As Integer, addr As sockaddr_in, addrlen As Integer) As Integer
Declare Function getsockname Lib "WinSock.DLL" (ByVal s As Integer, addr As sockaddr_in, addrlen As Integer) As Integer
Declare Function getsockopt Lib "WinSock.DLL" (ByVal s As Integer, ByVal level As Integer, ByVal optname As Integer, optval As Any, optlen As Integer) As Integer
Declare Function htonl Lib "WinSock.DLL" (ByVal hostlong As Long) As Long
Declare Function htons Lib "WinSock.DLL" (ByVal hostshort As Integer) As Integer
Declare Function inet_addr Lib "WinSock.DLL" (ByVal cp As String) As Long
Declare Function inet_ntoa Lib "WinSock.DLL" (ByVal in As Long) As Long
Declare Function listen Lib "WinSock.DLL" (ByVal s As Integer, ByVal backlog As Integer) As Integer
Declare Function ntohl Lib "WinSock.DLL" (ByVal netlong As Long) As Long
Declare Function ntohs Lib "WinSock.DLL" (ByVal netshort As Integer) As Integer
Declare Function recv Lib "WinSock.DLL" (ByVal s As Integer, ByVal buf As String, ByVal buflen As Integer, ByVal flags As Integer) As Integer
Declare Function recvfrom Lib "WinSock.DLL" (ByVal s As Integer, ByVal buf As String, ByVal buflen As Integer, ByVal flags As Integer, from As sockaddr_in, fromlen As Integer) As Integer
'***  Please note the Alias clause in the SELECT(S) function.  This is necessary because
'***  "SELECT" is a Visual Basic keyword.
Declare Function WSselect Lib "WinSock.DLL" Alias "select" (ByVal w As Integer, readfds As Any, writefds As Any, exceptfds As Any, timeout As timeval) As Integer
Declare Function send Lib "WinSock.DLL" (ByVal s As Integer, ByVal msg As String, ByVal msglen As Integer, ByVal flags As Integer) As Integer
Declare Function sendto Lib "WinSock.DLL" (ByVal s As Integer, ByVal msg As String, ByVal msglen As Integer, ByVal flags As Integer, addr As sockaddr_in, ByVal addrlen As Integer) As Integer
Declare Function setsockopt Lib "WinSock.DLL" (ByVal s As Integer, ByVal level As Integer, ByVal optname As Integer, optval As Any, ByVal optlen As Integer) As Integer
Declare Function Socket Lib "WinSock.DLL" (ByVal domain As Integer, ByVal domaintype As Integer, ByVal protocol As Integer) As Integer

'* Database function prototypes

Declare Function gethostbyaddr Lib "WinSock.DLL" (ByVal addr As String, addrlen As Integer, addrtype As Integer) As Long
Declare Function gethostbyname Lib "WinSock.DLL" (ByVal host As String) As Long
Declare Function gethostname Lib "WinSock.DLL" (ByVal host As String, ByVal hostlen As Integer) As Integer
Declare Function getservbyport Lib "WinSock.DLL" (ByVal port As Integer, ByVal proto As String) As Long
Declare Function getservbyname Lib "WinSock.DLL" (ByVal service As String, ByVal proto As String) As Long
Declare Function getprotobynumber Lib "WinSock.DLL" (ByVal proto As Integer) As Long
Declare Function getprotobyname Lib "WinSock.DLL" (ByVal proto As String) As Long

'* Microsoft Windows Extension function prototypes

Declare Function WSAStartUp Lib "WinSock.DLL" (ByVal wVersionRequired As Integer, lpWSAData As WSADATA) As Integer
Declare Function WSACleanup Lib "WinSock.DLL" () As Integer
Declare Sub WSASetLastError Lib "WinSock.DLL" (iError As Integer)
Declare Function WSAGetLastError Lib "WinSock.DLL" () As Integer
Declare Function WSAIsBlocking Lib "WinSock.DLL" () As Integer
Declare Function WSAUnhookBlockingHook Lib "WinSock.DLL" () As Integer
Declare Function WSASetBlockingHook Lib "WinSock.DLL" (ByVal lpBlockFunc As Long) As Long
Declare Function WSACancelBlockingCall Lib "WinSock.DLL" () As Integer
Declare Function WSAAsyncGetServByName Lib "WinSock.DLL" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal aName As String, ByVal proto As String, ByVal buf As String, ByVal buflen As Integer) As Integer
Declare Function WSAAsyncGetServByPort Lib "WinSock.DLL" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal port As Integer, ByVal proto As String, ByVal buf As String, ByVal buflen As Integer) As Integer
Declare Function WSAAsyncGetProtoByName Lib "WinSock.DLL" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal aName As String, ByVal buf As String, ByVal buflen As Integer) As Integer
Declare Function WSAAsyncGetProtoByNumber Lib "WinSock.DLL" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal aNumber As Integer, ByVal buf As String, ByVal buflen As Integer) As Integer
Declare Function WSAAsyncGetHostByName Lib "WinSock.DLL" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal aName As String, ByVal buf As String, ByVal buflen As Integer) As Integer
Declare Function WSAAsyncGetHostByAddr Lib "WinSock.DLL" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal addr As String, ByVal addrlen As Integer, ByVal addrtype As Integer, ByVal buf As String, ByVal buflen As Integer) As Integer
Declare Function WSACancelAsyncRequest Lib "WinSock.DLL" (ByVal hAsyncTaskHandle As Integer) As Integer
Declare Function WSAASYNCSELECT Lib "WinSock.DLL" (ByVal s As Integer, ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal lEvent As Long) As Integer

Sub fd_zero (p As fd_set)
'*********************************************************
'***  This function simulates the following C macro:   ***
'***  FD_ZERO(p)   _fmemset(lp, 0, sizeof(*(p))        ***
'*********************************************************

'***  Zero out the entire "array"

For i = 0 To FD_SETSIZE
    p.fd_array(i) = 0
Next i

p.fd_count = 0

'***  END fd_zero subroutine.

End Sub

